package main;

import java.io.File;

/**
 * In one instance there are the paths used to read and write relative to this project location defined.
 * Here there are also the default values defined (in the source code).
 * 
 * These paths can be set to values relative to the location of this Java-project (do not start with File.separator)
 */
public class PathsConfig {
	
	/*
	 * Default-values are specified here!
	 */
	public String pathToGraphs = "data"+File.separator+"graphs"; //old value: "data"+File.separator+"Testgraphen"
	public String pathToGraphSpecifications = this.pathToGraphs+File.separator+"specifications"; //old value: data"+File.separator+"Testgraphen+File.separator+"Spezifizierungen"
	public String pathForIpeExport = "data"+File.separator+"ipe-files"; //old value: "data"+File.separator+"Ipe-Files"
	public String pathToComputationData = "data"+File.separator+"computation_data"; //old value: "data"+File.separator+"BerechnungsergebnisseZuDenTestgraphen"
	public String pathToCPlusPlusResults = "data"+File.separator+"C++_results"; //old value: "data"+File.separator+"C++Zwischenergebnisse"
	public String pathToSaveCSVFilesFromSplitTreeTest = "data"+File.separator+"split-tree-test"; //old value: "data"+File.separator+"SplitTree-Test"
	
	
	public boolean containsNullValues(){
		if(pathToGraphs==null){
			return true;
		}
		if(pathToGraphSpecifications==null){
			return true;
		}
		if(pathForIpeExport==null){
			return true;
		}
		if(pathToComputationData==null){
			return true;
		}
		if(pathToCPlusPlusResults==null){
			return true;
		}
		if(pathToSaveCSVFilesFromSplitTreeTest==null){
			return true;
		}
		return false;
	}

	/**
	 * 
	 * @return
	 * Number of replaced values
	 */
	public int replaceNullValuesWithDefaultValues(){
		PathsConfig defaultValues = new PathsConfig();
		int counter = 0;
		
		if(pathToGraphs==null){
			this.pathToGraphs = defaultValues.pathToGraphs;
			++counter;
		}
		if(pathToGraphSpecifications==null){
			this.pathToGraphSpecifications = defaultValues.pathToGraphSpecifications;
			++counter;
		}
		if(pathForIpeExport==null){
			this.pathForIpeExport = defaultValues.pathForIpeExport;
			++counter;
		}
		if(pathToComputationData==null){
			this.pathToComputationData = defaultValues.pathToComputationData;
			++counter;
		}
		if(pathToCPlusPlusResults==null){
			this.pathToCPlusPlusResults = defaultValues.pathToCPlusPlusResults;
			++counter;
		}
		if(pathToSaveCSVFilesFromSplitTreeTest==null){
			this.pathToSaveCSVFilesFromSplitTreeTest = defaultValues.pathToSaveCSVFilesFromSplitTreeTest;
			++counter;
		}
		return counter;
	}
	
	public void createSaveDirectoriesThatDoNotExist(){
		File dirForIpeExport = new File(pathForIpeExport);
		if(!dirForIpeExport.exists()){
			dirForIpeExport.mkdirs();
		}
		
		File dirToComputationData = new File(pathToComputationData);
		if(!dirToComputationData.exists()){
			dirToComputationData.mkdirs();
		}

		File dirToCPlusPlusResults = new File(pathToCPlusPlusResults);
		if(!dirToCPlusPlusResults.exists()){
			dirToCPlusPlusResults.mkdirs();
		}
		
		File dirToSaveCSVFilesFromSplitTreeTest = new File(pathToSaveCSVFilesFromSplitTreeTest);
		if(!dirToSaveCSVFilesFromSplitTreeTest.exists()){
			dirToSaveCSVFilesFromSplitTreeTest.mkdirs();
		}
	}
}
